Unit DE50R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AS09R_p, II10R_p, UTDE10_p;

procedure DE50R(NX :Integer; XN :Real; XK :Real;
                var CN :Array of Real; var CK :Array of Real;
                var F :Array of Real; var G :Array of Real;
                var R :Array of Real; EPS :Real; var IMAX :Integer;
                var Y :Array of Real; var IK :Integer;
                var DELTY :Array of Real; var RAB :Array of Real;
                var IERR :Integer);

implementation

procedure DE50R(NX :Integer; XN :Real; XK :Real;
                var CN :Array of Real; var CK :Array of Real;
                var F :Array of Real; var G :Array of Real;
                var R :Array of Real; EPS :Real; var IMAX :Integer;
                var Y :Array of Real; var IK :Integer;
                var DELTY :Array of Real; var RAB :Array of Real;
                var IERR :Integer);
var
IE,NP,NP2,NP3,NP4,NP5,NP6,NP7,N,NL,IB,M1,M2,M3,NPHRT,J,IC,NC,NA,NB,J2,
   NE,NF,ID,NG,JJ,NH :Integer;
DX,ZA,Z,CA,CB :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_3000,_10,_11,_12,_13,_14,_15,_16,_17,_18,
_19,_20,_21,_22,_23,_24;
begin
IERR := 0;
if ( IMAX ) < 0
 then goto _1
 else if ( IMAX ) > 0
       then goto _3
       else goto _3;
_1:
IMAX := -IMAX;
for IE:=1 to NX do
 begin
  Y[IE-1] := 0.0;
_2:
 end;
goto _10;
_3:
if ( Abs(CN[1-1])+Abs(CN[2-1]) ) < 0
 then goto _4
 else if ( Abs(CN[1-1])+Abs(CN[2-1]) ) > 0
       then goto _5
       else goto _4;
_4:
IERR := 65;
goto _23;
_5:
if ( Abs(CK[1-1])+Abs(CK[2-1]) ) < 0
 then goto _6
 else if ( Abs(CK[1-1])+Abs(CK[2-1]) ) > 0
       then goto _7
       else goto _6;
_6:
IERR := 66;
goto _23;
_7:
NP := NX;
NP2 := NP+NP;
NP3 := NP2+NP;
NP4 := NP3+NP;
NP5 := NP4+NP;
NP6 := NP5+NP;
NP7 := NP6+NP;
N := NP-1;
NL := NP-2;
DX := (XK-XN)/(N);
ZA := IntPower(DX,2)*0.5;
RAB[NP+0] := -CN[0]+DX*CN[1]+ZA*(G[0]*CN[0]-F[0]*CN[1]);
RAB[NP2+0] := CN[0];
RAB[NP3+0] := DX*CN[2]+ZA*(R[0]*CN[0]-F[0]*CN[2]);
RAB[NP-1] := CK[0];
RAB[NP2-1] := -CK[0]-DX*CK[1]+ZA*(G[NP-1]*CK[0]-F[NP-1]*CK[1]);
RAB[NP4-1] := -DX*CK[2]+ZA*(R[NP-1]*CK[0]-F[NP-1]*CK[2]);
Y[0] := 0.0;
DELTY[0] := 0.0;
Y[NP-1] := 0.0;
DELTY[NP-1] := 0.0;
for IB:=2 to N do
 begin
  Y[IB-1] := 0.0;
  DELTY[IB-1] := 0.0;
  Z := 0.5*DX*F[IB-1];
  RAB[IB-1] := 1.0-Z;
  M1 := NP+IB;
  M2 := NP2+IB;
  M3 := NP3+IB;
  RAB[M1-1] := IntPower(DX,2)*G[IB-1]-2.0;
  RAB[M2-1] := 1.0+Z;
  RAB[M3-1] := IntPower(DX,2)*R[IB-1];
_8:
 end;
NPHRT := NP3+1;
AS09R(NP,NP,3,1,1,RAB,RAB[NPHRT-1]);
if ( IMAX ) < 0
 then goto _9
 else if ( IMAX ) > 0
       then goto _10
       else goto _9;
_9:
J := 1;
for IC:=1 to NP do
 begin
  NC := NP3+IC;
  Y[IC-1] := Y[IC-1]+RAB[NC-1];
_3000:
 end;
IK := 0;
goto _24;
_10:
for J:=1 to IMAX do
 begin
_11:
  for IC:=1 to NP do
   begin
    NC := NP3+IC;
    Y[IC-1] := Y[IC-1]+RAB[NC-1];
    if ( J-1 ) < 0
     then goto _13
     else if ( J-1 ) > 0
           then goto _12
           else goto _13;
_12:
    DELTY[IC-1] := DELTY[IC-1]+RAB[NC-1];
_13:
   end;
  if ( IMAX ) < 0
   then goto _14
   else if ( IMAX ) > 0
         then goto _15
         else goto _14;
_14:
  IK := 0;
  goto _24;
_15:
  NPHRT := NP3+1;
  II10R(NP,1,1,NP,4,0,RAB[NPHRT-1]);
  RAB[NP7+1] := RAB[NP7+2];
  RAB[NP6+1] := RAB[NP6+2]-RAB[NP7+1];
  NA := NP7+N;
  RAB[NA-1] := RAB[NA-2];
  NB := NP6+N;
  RAB[NP7-1] := RAB[NA-1]+RAB[NB-1];
  for J2:=2 to N do
   begin
    if ( F[J2-1] ) < 0
     then goto _17
     else if ( F[J2-1] ) > 0
           then goto _17
           else goto _16;
_16:
    CA := 0.0;
    goto _18;
_17:
    NC := NP6+J2+1;
    CA := -(RAB[NC-2]+RAB[NC-1])/12.0;
_18:
    NE := NP7+J2;
    CB := -RAB[NE-1]/12.0;
    NF := NP3+J2;
    RAB[NF-1] := -(CB+CA*DX*F[J2-1]);
_19:
   end;
  RAB[NP3+0] := CN[0]*(4*RAB[NP6+1]+3*RAB[NP7+1])/24.0;
  RAB[NP4-1] := CK[0]*(RAB[NA-2]-4*RAB[NP7-1])/24.0;
  NPHRT := NP3+1;
  AS09R(NP,NP,3,1,0,RAB,RAB[NPHRT-1]);
  for ID:=1 to NP do
   begin
    NG := NP3+ID;
    if ( Abs(RAB[NG-1])-EPS ) < 0
     then goto _20
     else if ( Abs(RAB[NG-1])-EPS ) > 0
           then goto _22
           else goto _20;
_20:
   end;
  for JJ:=1 to NP do
   begin
    NH := NP3+JJ;
    DELTY[JJ-1] := DELTY[JJ-1]+RAB[NH-1];
    Y[JJ-1] := Y[JJ-1]+RAB[NH-1];
_21:
   end;
  IK := J;
  goto _24;
_22:
 end;
IERR := 1;
IK := -1;
_23:
UTDE10(IERR,50);
_24:
end;

end.
